#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "Dead_AntiFlood";

#define MAX_FLOOD	6							//amount of *flood* required
#define WARN_FLOOD	3							//amount of flood before warned
#define FLOOD_TIME	2							//if more then MAX_FLOOD in FLOOD_TIME
#define MUTE_TIME	15							//time to mute for

new SendTimes[MAX_PLAYERS][MAX_FLOOD];						//one line for each *time* before kick
new MutedUser[MAX_PLAYERS];							//list of muted users

CheckUser(User[], UserIndex) {							//0 = talk, 1 = muted, -1 kick, 2 = immune
	new Time;
	new i;
	new Temp1;
	new Temp2;

	if(check_immunity(User) == 1) {
		return 2;							//player immune by admin_mod
	}
	Temp1 = SendTimes[UserIndex -1][0];							//save first time
	Time = SendTimes[UserIndex -1][0] = systemtime();						//put newest time
	for (i = 1; i <= MAX_FLOOD-2; i += 1) {
		Temp2 = SendTimes[UserIndex -1][i];						//save this one
		SendTimes[UserIndex -1][i] = Temp1;						//shuffle back one
		Temp1 = Temp2;							//copy *this* one back so it won't be lost
	}
	SendTimes[UserIndex -1][MAX_FLOOD-1] = Temp1;							//save the last one
	if ((SendTimes[UserIndex -1][0] - FLOOD_TIME) <= SendTimes[UserIndex -1][MAX_FLOOD-1]) {			//god damn llama
		return -1;							//tell to kick
	} else if ((SendTimes[UserIndex -1][0] - FLOOD_TIME) <= SendTimes[UserIndex -1][WARN_FLOOD-1]) {		//to the warn point
		if (MutedUser[UserIndex -1] == 0) {
			RemindMuted(User);
			MutedUser[UserIndex -1] = Time;
		}
		return 1;							//tell to mute
	} else if ((MutedUser[UserIndex -1] >= Time - MUTE_TIME )&&(MutedUser[UserIndex -1])) {
		return 1;							//still muted
	} else {
		MutedUser[UserIndex -1] = 0;
		return 0;
	}
	return 0;								//person is safe...FOR NOW!!!
}

KickLlama(User[]) {								//warn the server about this.
	new Text[MAX_TEXT_LENGTH];						//temp string to print out
	snprintf(Text, MAX_TEXT_LENGTH, "Server Bot: %s has been kicked for excessive flood [ADMIN]", User);
	say(Text);								//say the little ditty
	kick(User);								//Kick the little bugger
}

RemindMuted(User[]) {								//person still in warn area, they get muted :)
	new Text[MAX_TEXT_LENGTH];						//temp string to print out
	snprintf(Text, MAX_TEXT_LENGTH, "Server Bot: %s has been muted for excessive flood [ADMIN]", User);
	messageex(User, Text, print_center);					//say the little ditty
	messageex(User, Text, print_console);					//say the little ditty in his console
}

public plugin_connect(HLUserName, HLIP, UserIndex) {				//initialize on connect
	new i;
	if ((UserIndex >= 1) && (UserIndex <= MAX_PLAYERS))				//if it is actually a player
	{
		for (i = 0; i <= MAX_FLOOD-1; i += 1)
		{
			SendTimes[UserIndex -1][i] = systemtime() - (FLOOD_TIME * i);
										//initialize the whole array so it can't do nothing
		}
		MutedUser[UserIndex -1] = 0;					//set non muted flag :)
	}
	return PLUGIN_CONTINUE;							//continue
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {			//grab chat
	new User[MAX_NAME_LENGTH];
	new i;
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if (UserIndex == 0) {
		return PLUGIN_CONTINUE;						//Disregaurd console chat
	}
	i = CheckUser(User, UserIndex);
	if (i == 0) {
		return PLUGIN_CONTINUE;						//person ok to talk
	} else if (i == 1) {
//		RemindMuted(User);						//remind them they are muted
		return PLUGIN_HANDLED;						//person muted
	} else if (i == -1) {
		KickLlama(User);						//see the door, bee the door
		return PLUGIN_HANDLED;						//person kicked for excessive flood
	} else {
		return PLUGIN_CONTINUE;						//person is immune ????
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {								//register this plugin in hl so it works
	plugin_registerinfo("Dead_AntiFlood","Mutes flooders/Kicks Flooders.",STRING_VERSION);
	plugin_registercmd("say","HandleSay",ACCESS_ALL);			//were to start count and to mute
	plugin_registercmd("say_team", "HandleSay", ACCESS_ALL);		//mute them in team chat as well

	return PLUGIN_CONTINUE;							//continue with other plugin regs
}